﻿Public Class Calc_2D

    '２円の交点を求める
    Shared Function crcir(ByVal center(,) As Double, ByVal R() As Double, ByRef cross_point(,) As Double) As Integer

        Dim ii, jj As Integer
        Dim x0, y0, x1, y1, x5, y5 As Double
        Dim a, aa, b, e, f, h, i, l, l2, m, o, p As Double
        Dim a1, d As Double
        Dim vr0(1), vx(1), vy(1), r0, r1, r2, r3, cosq1, sinq1 As Double
        Dim offset, offset1 As Double

        '２円のX座標が同じ時の例外処理
        If center(0, 0) = center(1, 0) Then
            'printf("例外処理が発生しました。crcirで０の割り算が発生しました。\n")
            'printf("２円のx座標が同じになっています。\n")

            x0 = center(0, 0)
            y0 = center(0, 1)
            x1 = center(1, 0)
            y1 = center(1, 1)

            d = center(1, 1) - center(0, 1)
            a1 = ((R(0) * R(0)) - (R(1) * R(1)) + (d * d)) / (2 * d)
            aa = (R(0) * R(0)) - (a1 * a1)
            If (aa < 0.0) Then
                'printf("２円の交点が求まりません(crcir)\n")
                Return (-1)
            End If
            b = aa ^ 0.5

            center(0, 0) = x0 - b
            center(0, 1) = y0 + a1

            center(1, 0) = x0 + b
            center(1, 1) = y0 + a1

            Return (0)
        End If

        offset1 = 0.0
        For ii = 0 To ii = 1
            For jj = 0 To jj = 2
                If center(ii, jj) < offset1 Then offset1 = center(ii, jj)
            Next jj
        Next ii

        offset = (R(0) + R(1)) * 2 - offset1

        h = center(0, 0) + offset
        i = center(0, 1) + offset
        e = center(1, 0) + offset
        f = center(1, 1) + offset
        r1 = R(0)
        r2 = R(1)
        r3 = r1 + r2

        vr0(0) = e - h
        vr0(1) = f - i
        r0 = (vr0(0) * vr0(0) + vr0(1) * vr0(1)) ^ 0.5

        'まず交点が作成可能かチェック、ダメならエラー*/
        If (r0 > r3) Then
            Return (-1)
        End If

        cosq1 = (r0 * r0 + r1 * r1 - r2 * r2) / (2 * r0 * r1)
        sinq1 = (1 - cosq1 * cosq1) ^ 0.5

        vx(0) = vr0(0) / r0
        vx(1) = vr0(1) / r0
        vy(0) = -vx(1)
        vy(1) = vx(0)

        l = r1 * cosq1 * vx(0) + r1 * sinq1 * vy(0) + h
        m = r1 * cosq1 * vx(1) + r1 * sinq1 * vy(1) + i

        'printf("x = %f   y = %f \n",l,m)
        cross_point(0, 0) = l - offset
        cross_point(0, 1) = m - offset

        a = vx(1) / vx(0)
        b = vy(1) / vy(0)
        x5 = (a * h - b * l + m - i) / (a - b)
        y5 = a * (x5 - h) + i
        a = x5 - l
        b = y5 - m
        l2 = (a * a + b * b) ^ 0.5
        o = -vy(0) * 2 * l2 + l
        p = -vy(1) * 2 * l2 + m

        'printf("x = %f   y = %f \n",o,p)
        cross_point(1, 0) = o - offset
        cross_point(1, 1) = p - offset

        Return (0)

    End Function

    '２点間の距離を求める
    Shared Function dist2points(ByVal coo(,) As Double) As Double
        Dim distance As Double

        distance = ((coo(0, 0) - coo(1, 0)) ^ 2 + (coo(0, 1) - coo(1, 1)) ^ 2) ^ 0.5

        Return (distance)
    End Function

End Class
