﻿Imports System.Windows.Forms.Application

Public Class RoboIO_GPS

    '************************************************************************
    '緯度／経度を保持するための構造体
    Public Structure position

        Public N_deg As Double
        Public N_min As Double

        Public E_deg As Double
        Public E_min As Double

    End Structure

    '************************************************************************
    'ロボットＩ／Ｏクラス
    '移動ユニットのＧＰＳ制御関連
    'はじめに作ったSub。取り込みが非効率
    Shared Sub read_GPS0(ByRef org_data As String)

        '変数定義
        Dim buff2(256) As Byte
        Dim i, j As Integer
        Dim response As MsgBoxResult

        Try
            frmMain.SerialPort2.BaudRate = frmMain.ComboBox2.Text
            frmMain.SerialPort2.PortName = frmMain.comboComID2.Text
            'ポートオープン
            frmMain.SerialPort2.Open()
        Catch ex As IO.IOException
            response = MsgBox("エラー！シリアルポートＣｈＢのオープンに失敗しました。", MsgBoxStyle.Information)
            'Exit Try
            Exit Sub
        Catch ex As UnauthorizedAccessException
            response = MsgBox("エラー！シリアルポートＣｈＢのオープンに失敗しました。", MsgBoxStyle.Information)
            'Exit Try
            Exit Sub
        End Try

        'GPSのテキストデータ受信
        frmMain.SerialPort2.DiscardInBuffer()
        Do
            '受信完了を待つ
            System.Windows.Forms.Application.DoEvents()
            i = frmMain.SerialPort2.BytesToRead
        Loop Until i > 57 * 2

        '受信したデータをバッファに取り込む
        frmMain.SerialPort2.Read(buff2, 0, 57 * 2)

        '変数クリア
        org_data = ""
        j = 0
        For i = 0 To 56
            If Chr(buff2(i)) = "@" Then
                For j = 0 To 56
                    org_data = org_data + Chr(buff2(i + j))
                Next j
            End If
            If j > 0 Then i = 57
        Next i

        Try
            'ポートクローズ
            frmMain.SerialPort2.Close()
        Catch ex As IO.IOException
            response = MsgBox("エラー！シリアルポートＣｈＢのクローズに失敗しました。", MsgBoxStyle.Information)
        End Try

    End Sub

    '************************************************************************
    'ＧＰＳから受け取ったストリングを緯度経度のストリングに分割する
    'ｅＴｒｅｘＨのＴｅｘｔ　Ｏｕｔモード用。座標はＷＧＳ８４
    Shared Sub get_latitude_longitude(ByVal gpstext_work As String, ByRef position As position)
        Dim work_ptr As Integer

        work_ptr = 15
        position.N_deg = Val(Mid(gpstext_work, work_ptr, 2))
        position.N_min = Val(Mid(gpstext_work, work_ptr + 2, 2)) + Val(Mid(gpstext_work, work_ptr + 2 + 2, 3)) / 1000

        work_ptr = 23
        position.E_deg = Val(Mid(gpstext_work, work_ptr, 3))
        position.E_min = Val(Mid(gpstext_work, work_ptr + 3, 2)) + Val(Mid(gpstext_work, work_ptr + 3 + 2, 3)) / 1000

    End Sub

    '************************************************************************
    'ＧＰＳから受け取ったストリングを緯度経度のストリングに分割する
    'ｅＴｒｅｘＨのＴｅｘｔ　Ｏｕｔモード用。座標はＮＭＥＡ－１８３
    Shared Sub get_latitude_longitude_NMEA(ByVal gpstext_work As String, ByRef position As position)

        Dim work_word() As String

        work_word = gpstext_work.Split(",")

        '日本国内を前提として簡略化しているため、他地域で動かすときは見直しのこと
        'lengthがゼロの時は衛星を全く捕捉していない
        '$GPGGA,234722,3502.4011,N,13653.8724,E,1,12,0.9,5.9,M,34.1,M,,*4B・・・サンプル
        If work_word.Length > 3 Then
            If work_word(4).Length > 0 Then
                position.E_deg = Mid(work_word(4), 1, 3)
                position.E_min = Mid(work_word(4), 4, 7)

                position.N_deg = Mid(work_word(2), 1, 2)
                position.N_min = Mid(work_word(2), 3, 7)
            End If
        End If


    End Sub
End Class
