﻿Public Class frmSonicScan

    '戻る　ボタンの処理
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Visible = False
        frmJoint.Visible = True
    End Sub

    'スキャン　ボタンの処理
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        '変数定義
        Dim scan_width, scan_step, distance(32) As Integer

        'スキャン幅とステップをセットする
        scan_width = 70
        scan_step = scan_width / 7

        '「スキャンボタン」を緑にする
        Button2.BackColor = Color.GreenYellow

        'スキャンを実行する
        Call scan_Sonic(scan_width, scan_step, distance)

        '「スキャンボタン」を白に戻す
        Button2.BackColor = Color.White

        'レーダーチャートを描く
        draw_rader_chart(scan_width, scan_step, distance)

    End Sub
    'スキャン動作を実行する******************************************
    '引数
    '　scan_width：スキャンの幅（度単位）
    '　scan_step：スキャンのステップ（度単位）
    '　distance：測定結果
    '戻り値
    '　ＲＣサーボ出力データ
    Public Sub scan_Sonic(ByVal scan_width As Integer, ByVal scan_step As Integer, ByRef distance() As Integer)
        '変数定義
        Dim data_num, servo_data, direction As Integer
        Dim servo_st_en(6) As Double
        Dim i As Integer
        Dim a As Double


        '関節パラメータセット（後日必要あれば関節パラメータファイルから読むように変更2009/11/08）
        servo_st_en(0) = -45
        servo_st_en(1) = 630
        servo_st_en(2) = 0
        servo_st_en(3) = 1555
        servo_st_en(4) = 45
        servo_st_en(5) = 2505

        servo_data = angle2servo(-scan_width, servo_st_en)
        '首を測定方向へ動かす
        Values.joint_data_new(2) = servo_data
        SIO.move_servo(25, Values.joint_data_new, Values.joint_data_last)

        data_num = 0
        For direction = -scan_width To scan_width Step scan_step
            servo_data = angle2servo(direction, servo_st_en)
            '首を測定方向へ動かす
            Values.joint_data_new(2) = servo_data
            SIO.move_servo(Values.joint_data_new, Values.joint_data_last)
            '0.2秒待つ
            System.Threading.Thread.Sleep(200)

            'スキャン開始

            '測定実行
            SIO.get_sonic_dist(a)
            distance(data_num) = a * 1000 'm --> mm変換
            data_num = data_num + 1
        Next

        '首を元に戻す
        servo_data = angle2servo(0, servo_st_en)
        Values.joint_data_new(2) = servo_data
        SIO.move_servo(25, Values.joint_data_new, Values.joint_data_last)

        Dim min_dist As Double = 9999.0
        Dim max_dist As Double = 0.0
        For i = 0 To data_num - 1
            If distance(i) > max_dist Then max_dist = distance(i)
            If distance(i) < min_dist Then min_dist = distance(i)
        Next

        txtMessages.Text = ""

        txtMessages.AppendText("測定角度（±°）：")
        txtMessages.AppendText(scan_width)
        txtMessages.AppendText(vbCrLf)
        txtMessages.AppendText("測定ピッチ（°）：")
        txtMessages.AppendText(scan_step)
        txtMessages.AppendText(vbCrLf)
        txtMessages.AppendText("最小距離(mm)　　：")
        txtMessages.AppendText(min_dist)
        txtMessages.AppendText(vbCrLf)
        txtMessages.AppendText("最大距離(mm)　　：")
        txtMessages.AppendText(max_dist)
        txtMessages.AppendText(vbCrLf)

        Dim work_str1, work_str2 As String
        For i = 0 To data_num - 1

            work_str1 = Format(i, "##")
            work_str1 = work_str1.PadLeft(3)
            work_str2 = Format(distance(i), "####")
            work_str2 = work_str2.PadLeft(6)
            txtMessages.AppendText(work_str1 + ":" + work_str2 + vbCrLf)
        Next
        txtMessages.Refresh()

    End Sub
    'レーダーチャートを描く******************************************
    '引数
    '　scan_width：スキャンした角度（度単位）
    '　scan_step：スキャンのステップ（度単位）
    '　distance：測定結果
    Private Sub draw_rader_chart(ByVal scan_width As Integer, ByVal scan_step As Integer, _
                ByVal ParamArray distance() As Integer)
        '変数定義
        Dim data_h(2), work(2) As Byte
        Dim i, j, xs1, ys1, xe1, ye1, base_x, base_y As Integer
        Dim magni, theta As Double

        Dim myPen As New Pen(Color.Indigo)
        Dim formGraphics As Graphics

        '座標原点の定義
        base_x = PictureBox1.Size.Width * 0.5
        base_y = PictureBox1.Size.Height * 0.9

        '描画倍率の定義（PictureBoxの高さを6000mmと対応させる）
        magni = PictureBox1.Size.Height / 6000

        PictureBox1.Refresh()
        formGraphics = PictureBox1.CreateGraphics()

        '座標軸を描く
        myPen.Color = ColorTranslator.FromOle(RGB(0, 0, 0))
        'Ｘ軸
        xs1 = 0
        ys1 = base_y
        xe1 = PictureBox1.Size.Width
        ye1 = base_y
        formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)

        'Ｙ軸
        xs1 = base_x
        ys1 = 0
        xe1 = base_x
        ye1 = base_y
        formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)

        '測定結果を描く
        myPen.Color = ColorTranslator.FromOle(RGB(255, 0, 0))
        j = 0
        For i = -scan_width To scan_width Step scan_step
            theta = (i + 90) / 180 * 3.14159

            xs1 = xe1
            ys1 = ye1
            xe1 = base_x + distance(j) * magni * System.Math.Cos(theta)
            ye1 = base_y - distance(j) * magni * System.Math.Sin(theta)
            formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)

            j = j + 1
        Next i
        formGraphics.DrawLine(myPen, base_x, base_y, xe1, ye1)

        '終了処理
        myPen.Dispose()
        formGraphics.Dispose()
    End Sub

    '関節の角度を直線補間でＲＣサーボへの出力データに変換する。（首関節用）**********************
    '引数
    '　joint_angle：関節角度（度単位）
    '　servo_st_en：関節パラメータ
    '戻り値
    '　ＲＣサーボ出力データ
    Public Function angle2servo(ByVal joint_angle As Double, _
                ByVal ParamArray servo_st_en() As Double) As Integer
        '変数定義
        Dim servo_data As Integer
        Dim a, b As Double

        '補間直線の傾きを求める
        If joint_angle > servo_st_en(2) Then
            a = (servo_st_en(5) - servo_st_en(3)) / (servo_st_en(4) - servo_st_en(2))
        Else
            a = (servo_st_en(3) - servo_st_en(1)) / (servo_st_en(2) - servo_st_en(0))
        End If

        '補間直線のＹ切片を求める
        b = servo_st_en(3) - a * servo_st_en(2)

        servo_data = Int((a * joint_angle + b))

        Return servo_data

    End Function
End Class