﻿Public Class img1

    'ステレオマッチングの結果から測定対象のカメラを基準とした座標を求める
    Shared Sub get_coordinate(ByRef target_X As Double, ByRef target_Y As Double, ByRef target_Z As Double)

        Dim data_num As Integer

        Dim a1, a2, b1, b2, c1, eye_dist, screen_dist As Double
        Dim min_dist_x As Double

        eye_dist = 140.0    'カメラ間の距離（ｍｍ）
        screen_dist = 295.0 '仮想スクリーンまでの距離、単位はmm
        min_dist_x = 200.0  '最低測定距離（マッチングに失敗した時のマイナス距離などを撥ねる）

        data_num = 0
        '左目線と右目線を２直線（y=ax+b）の交点を一時方程式を解いて求める要領で求めて目標座標とする。
        '左目をＹ軸の正側にとって計算実施、眼前方向にＸ軸の正とし、仮想スクリーンを定義した。
        a1 = (-Values.ROI_X + (Values.IMG_SIZE_H / 2.0)) / screen_dist
        b1 = eye_dist / 2.0

        '右目情報
        a2 = (-Values.ROI_X_R + Val(frmVision1.txtDirectionOffset_X.Text) + (Values.IMG_SIZE_H / 2.0)) / screen_dist
        b2 = -eye_dist / 2.0

        target_X = -(b1 - b2) / (a1 - a2)
        target_Y = a1 * target_X + b1

        c1 = (Values.IMG_SIZE_V / 2.0) - Values.ROI_Y
        target_Z = c1 / screen_dist * target_X

    End Sub
    Shared Sub ChangeROI_L(ByVal pen_type As Integer)

        '変数定義
        Dim ptr, X, Y, br, dest_x, dest_y, R, G, B As Integer
        Dim unit_x, unit_y As Integer

        Dim result_set(1024), work_str(16) As String

        Dim formGraphics As Graphics
        ' Create a new pen.
        Dim skyBluePen As New Pen(Brushes.DeepSkyBlue)
        Dim RedPen As New Pen(Brushes.Red)
        Dim Pict1 As New Bitmap(frmVision1.picLeftCam.Image)
        Dim PixelColor As Color

        'ROIを四角で囲んで表示
        '見て確認するためROIをpicturebox2へ表示
        formGraphics = frmVision1.picLeftCam.CreateGraphics()
        X = values.ROI_X
        Y = values.ROI_Y
        frmVision1.picLeftCam.Refresh()
        skyBluePen.Width = 1
        RedPen.Width = 3
        If pen_type = 0 Then
            formGraphics.DrawRectangle(skyBluePen, X, Y, values.ROI_width, values.ROI_height)
        Else
            formGraphics.DrawRectangle(RedPen, X, Y, values.ROI_width, values.ROI_height)
        End If
        formGraphics.Dispose()

        unit_x = 2
        unit_y = 2

        'ＲＯＩエリアのクリッピング
        If values.ROI_X + values.ROI_width > frmVision1.picLeftCam.Width Then values.ROI_X = frmVision1.picLeftCam.Width - values.ROI_width - 1
        If values.ROI_Y + values.ROI_height > frmVision1.picLeftCam.Height Then values.ROI_Y = frmVision1.picLeftCam.Height - values.ROI_height - 1

        'ROI小画面へコピー開始
        formGraphics = frmVision1.pictLeftWindow.CreateGraphics()
        dest_y = 0
        ptr = 0
        For Y = values.ROI_Y To values.ROI_Y + values.ROI_height - 1 Step values.ROI_magni
            dest_x = 0
            For X = values.ROI_X To values.ROI_X + values.ROI_width - 1 Step values.ROI_magni

                br = 0
                For local_y = Y To Y + values.ROI_magni - 1
                    For local_x = X To X + values.ROI_magni - 1
                        PixelColor = Pict1.GetPixel(local_x, local_y)
                        br = br + PixelColor.R
                        R = PixelColor.R
                        G = PixelColor.G
                        B = PixelColor.B
                    Next
                Next
                br = br / (values.ROI_magni * values.ROI_magni)

                values.vector(ptr) = br
                values.vector_L(0, ptr) = R
                values.vector_L(1, ptr) = G
                values.vector_L(2, ptr) = B

                ptr = ptr + 1

                'formGraphics.FillRectangle(New SolidBrush(ColorTranslator.FromOle(RGB(br, br, br))), dest_x, dest_y, unit_x, unit_y)
                formGraphics.FillRectangle(New SolidBrush(ColorTranslator.FromOle(RGB(R, G, B))), dest_x, dest_y, unit_x, unit_y)

                dest_x = dest_x + unit_x
            Next
            dest_y = dest_y + unit_y
        Next
        values.vector_num = ptr
        formGraphics.Dispose()

    End Sub

    'ＲＯＩ変更処理
    '右画像は左画像に連動して検査窓を動かすので、座標はイメージクリックではなく、呼び出し元ルーチンから与える
    Shared Sub ChangeROI_R(ByVal pen_type As Integer)

        '変数定義
        Dim ptr, br, X, Y, dest_x, dest_y, R, G, B As Integer
        Dim unit_x, unit_y As Integer

        Dim result_set(1024), work_str(16) As String

        Dim formGraphics As Graphics
        ' Create a new pen.
        Dim skyBluePen As New Pen(Brushes.DeepSkyBlue)
        Dim RedPen As New Pen(Brushes.Red)
        Dim Pict1 As New Bitmap(frmVision1.picRightCam.Image)
        Dim PixelColor As Color

        'ROIを四角で囲んで表示
        '見て確認するためROIをpicturebox2へ表示
        formGraphics = frmVision1.picRightCam.CreateGraphics()
        X = values.ROI_X_R
        Y = values.ROI_Y_R
        frmVision1.picRightCam.Refresh()
        skyBluePen.Width = 1
        RedPen.Width = 3
        If pen_type = 0 Then
            formGraphics.DrawRectangle(skyBluePen, X, Y, values.ROI_width, values.ROI_height)
        Else
            formGraphics.DrawRectangle(RedPen, X, Y, values.ROI_width, values.ROI_height)
        End If
        formGraphics.Dispose()

        unit_x = 2
        unit_y = 2

        'ＲＯＩエリアのクリッピング
        If values.ROI_X_R + values.ROI_width > frmVision1.picRightCam.Width Then values.ROI_X_R = frmVision1.picRightCam.Width - values.ROI_width - 1
        If values.ROI_Y_R + values.ROI_height > frmVision1.picRightCam.Height Then values.ROI_Y_R = frmVision1.picRightCam.Height - values.ROI_height - 1

        'ROI小画面へコピー開始
        formGraphics = frmVision1.pictRightWindow.CreateGraphics()
        dest_y = 0
        ptr = 0
        For Y = values.ROI_Y_R To values.ROI_Y_R + values.ROI_height - 1 Step values.ROI_magni
            dest_x = 0
            For X = values.ROI_X_R To values.ROI_X_R + values.ROI_width - 1 Step values.ROI_magni

                br = 0
                For local_y = Y To Y + values.ROI_magni - 1
                    For local_x = X To X + values.ROI_magni - 1
                        PixelColor = Pict1.GetPixel(local_x, local_y)
                        br = br + PixelColor.R
                        R = PixelColor.R
                        G = PixelColor.G
                        B = PixelColor.B
                    Next
                Next
                br = br / (values.ROI_magni * values.ROI_magni)

                values.vector(ptr) = br
                values.vector_R(0, ptr) = R
                values.vector_R(1, ptr) = G
                values.vector_R(2, ptr) = B

                ptr = ptr + 1

                'formGraphics.FillRectangle(New SolidBrush(ColorTranslator.FromOle(RGB(br, br, br))), dest_x, dest_y, unit_x, unit_y)
                formGraphics.FillRectangle(New SolidBrush(ColorTranslator.FromOle(RGB(R, G, B))), dest_x, dest_y, unit_x, unit_y)

                dest_x = dest_x + unit_x
            Next
            dest_y = dest_y + unit_y
        Next
        values.vector_num = ptr
        formGraphics.Dispose()

    End Sub
End Class
