﻿Public Class Values
    Public Shared org_back_color As Color
    Public Shared active_button_color As Color

    Public Shared IMG_SIZE_H = 320
    Public Shared IMG_SIZE_V = 240

    Public Shared ROI_width = 16
    Public Shared ROI_height = 16

    Public Shared ROI_X = (320 - ROI_width) / 2
    Public Shared ROI_Y = (240 - ROI_height) / 2

    Public Shared ROI_X_R = (320 - ROI_width) / 2
    Public Shared ROI_Y_R = (240 - ROI_height) / 2

    Public Shared ROI_magni As Double
    Public Shared ROI_vx, ROI_vy As Double

    Public Shared vector(255), vector_num As Integer
    Public Shared vector_L(2, 255) As Integer
    Public Shared vector_R(2, 255) As Integer
    Public Shared servo_min, servo_max As Integer

    Public Shared v_swap_image, v_min_pix_num, v_max_pix_num, v_left_cam_id As Integer
    Public Shared v_color_th, v_min_dist, v_max_dist As Double
    Public Shared turn_count_L1, turn_count_L2, turn_count_R1, turn_count_R2 As Double
    Public Shared turn_diameter_L1, turn_diameter_L2, turn_diameter_R1, turn_diameter_R2 As Double

    Public Shared ini_fname As String
    '              中立位置　　　　　　最終出力値　　　　　新しい出力値
    Public Shared joint_data_org(7), joint_data_last(7), joint_data_new(7) As Integer


    Shared Sub inits()
        Dim i As Integer

        Dim values As Values
        values = New Values

        ini_fname = "C:\Msdevstd\work\w7b2.ini"

        'ボタンの元の色を保存
        org_back_color = frmMain.btnComSwitch.BackColor

        'ボタンの元の色を保存
        active_button_color = Color.YellowGreen

        Values.ROI_vx = 0
        Values.ROI_vy = 0

        ROI_magni = 1.0

        'ＲＣサーボ初期出力値　セット（ｉｎｉファイルが無かった時のデフォルト）
        joint_data_org(0) = 1755
        joint_data_org(1) = 1870
        joint_data_org(2) = 1555
        joint_data_org(3) = 1720
        joint_data_org(4) = 1720
        joint_data_org(5) = 1720
        joint_data_org(6) = 1720
        joint_data_org(7) = 1720

        v_swap_image = 0
        v_color_th = 0.15
        v_min_dist = 300
        v_max_dist = 3000
        v_min_pix_num = 32
        v_max_pix_num = 20000
        v_left_cam_id = 0

        servo_max = 4150    'ＲＣサーボ出力最大値
        servo_min = 50     'ＲＣサーボ出力最小値

        'ini fileを読み込む
        values.ini_fread()

        'ＲＣサーボ出力データ初期化
        For i = 0 To 7
            joint_data_new(i) = joint_data_org(i)
            joint_data_last(i) = joint_data_org(i)
        Next

    End Sub

    Private Sub ini_fread()

        Dim work_str, work_str_arr() As String
        Dim i As Integer

        'ｉｎｉファイル読取
        If IO.File.Exists(ini_fname) Then
            FileOpen(1, ini_fname, OpenMode.Input)

            Do While Not EOF(1)

                work_str = LineInput(1)
                work_str_arr = work_str.Split(",")

                'ＲＣサーボ出力値のデフォルト
                For i = 0 To 7
                    work_str = "joint_data_org_" + Format(i)
                    If work_str_arr(0) = work_str Then
                        joint_data_org(i) = Val(work_str_arr(1))
                        joint_data_last(i) = joint_data_org(i)
                    End If
                Next

                'ステレオビジョン関係
                'イメージ表示の左右入れ替え
                If work_str_arr(0) = "chkSwapImage" Then
                    v_swap_image = Val(work_str_arr(1))
                End If
                '認識パラメータ
                If work_str_arr(0) = "frmVision1.txtColor_th" Then
                    v_color_th = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "frmVision1.txtMin_dist" Then
                    v_min_dist = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "frmVision1.txtMax_dist" Then
                    v_max_dist = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "frmVision1.txtMin_pixnum" Then
                    v_min_pix_num = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "frmVision1.txtMax_pixnum" Then
                    v_max_pix_num = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "frmVision1.txtLeft_cam_id" Then
                    v_left_cam_id = Val(work_str_arr(1))
                End If

                '旋回パラメーター
                If work_str_arr(0) = "turn_count_L1" Then
                    turn_count_L1 = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "turn_count_L2" Then
                    turn_count_L2 = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "turn_count_R1" Then
                    turn_count_R1 = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "turn_count_R2" Then
                    turn_count_R2 = Val(work_str_arr(1))
                End If

                If work_str_arr(0) = "turn_diameter_L1" Then
                    turn_diameter_L1 = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "turn_diameter_L2" Then
                    turn_diameter_L2 = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "turn_diameter_R1" Then
                    turn_diameter_R1 = Val(work_str_arr(1))
                End If
                If work_str_arr(0) = "turn_diameter_R2" Then
                    turn_diameter_R2 = Val(work_str_arr(1))
                End If
            Loop

            FileClose(1)
        Else
            MsgBox("w7b2.iniファイルが見つかりません。")
            Exit Sub
        End If

    End Sub

    Shared Sub ini_fwrite()

        Dim work_str As String
        Dim i As Integer

        FileOpen(1, ini_fname, OpenMode.Output)

        'ＲＣサーボ出力値のデフォルト
        PrintLine(1, "#ＲＣサーボ中立位置")
        For i = 0 To 7
            work_str = "joint_data_org_" + Format(i) + "," + Format(joint_data_org(i))
            PrintLine(1, work_str)
        Next

        PrintLine(1, "#イメージ表示の左右入れ替え")
        work_str = "chkSwapImage," + Format(v_swap_image)
        PrintLine(1, work_str)

        PrintLine(1, "#認識パラメータ")
        work_str = "frmVision1.txtColor_th," + Format(v_color_th)
        PrintLine(1, work_str)
        work_str = "frmVision1.txtMin_dist," + Format(v_min_dist)
        PrintLine(1, work_str)
        work_str = "frmVision1.txtMax_dist," + Format(v_max_dist)
        PrintLine(1, work_str)
        work_str = "frmVision1.txtMin_pixnum," + Format(v_min_pix_num)
        PrintLine(1, work_str)
        work_str = "frmVision1.txtMax_pixnum," + Format(v_max_pix_num)
        PrintLine(1, work_str)
        work_str = "frmVision1.txtLeft_cam_id," + Format(v_left_cam_id)
        PrintLine(1, work_str)

        PrintLine(1, "#旋回パラメーター")
        work_str = "turn_count_L1," + Format(turn_count_L1)
        PrintLine(1, work_str)
        work_str = "turn_count_L2," + Format(turn_count_L2)
        PrintLine(1, work_str)
        work_str = "turn_count_R1," + Format(turn_count_R1)
        PrintLine(1, work_str)
        work_str = "turn_count_R2," + Format(turn_count_R2)
        PrintLine(1, work_str)

        work_str = "turn_diameter_L1," + Format(turn_diameter_L1)
        PrintLine(1, work_str)
        work_str = "turn_diameter_L2," + Format(turn_diameter_L2)
        PrintLine(1, work_str)
        work_str = "turn_diameter_R1," + Format(turn_diameter_R1)
        PrintLine(1, work_str)
        work_str = "turn_diameter_R2," + Format(turn_diameter_R2)
        PrintLine(1, work_str)

        FileClose(1)

    End Sub
End Class
